<?php	session_start(); 
header("Content-type: text/xml");
	// conequery-vo.php
	// Matthew Whiting June 18 2007
	// 
	// A test of a VO-compliant conesearch query for the new data.
	// This should return a VOTable.
	//
	// The query parameters are RA, DEC, SR, all in decimal degrees.
	//
	// An example to test is conequery-vo.php?RA=0.&DEC=-49.&SR=1.
	//
	// Using Albert Teoh's query.php as a template
?>
<?php echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" ?>
<!DOCTYPE VOTABLE SYSTEM "http://us-vo.org/xml/VOTable.dtd">
<VOTABLE version="1.1" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:noNamespaceSchemaLocation="http://www.ivoa.net/xml/VOTable/VOTable/v1.1">
<?php
	include_once("../../database.php");
	include_once("../../utils.php");
	include_once("loadS70.php");

	$raj_degs         = trim(get_param('RA', $HTTP_GET_VARS));
	$decj_degs        = trim(get_param('DEC', $HTTP_GET_VARS));
	$radius           = trim(get_param('SR', $HTTP_GET_VARS));

	$errorMsg = "";
	$isError = False;  // Assume the best, that all three parameters are present and appropriate.
	
	// If all 3 parameters are present, all is good.
	if($raj_degs==""){
	 $isError=True;
	 $errorMsg .= "RA value not provided.; ";
	}
	if($decj_degs==""){           //	if(!isset($decj_degs)){
	 $isError=True;
	 $errorMsg .= "DEC value not provided.; ";
	}
	if($radius==""){		//	if(!isset($radius)){
	 $isError=True;
	 $errorMsg .= "SR value not provided.; ";
	}

	// If the parameters are not numeric, this is bad.
	if(($raj_degs!="") && !is_numeric($raj_degs)){
	 $isError=True;
	 $errorMsg .= "RA value not a number.; ";
	}
	if(($decj_degs!="") && !is_numeric($decj_degs)){
	 $isError=True;
	 $errorMsg .= "DEC value not a number.; ";
	}
	if(($radius!="") && !is_numeric($radius)){
	 $isError=True;
	 $errorMsg .= "SR value not a number.; ";
	}
	
	// If DEC is out of range, this is bad.
	if( is_numeric($decj_degs) && (abs($decj_degs) > 90.) ){
	 $isError = True;
	 $errorMsg .= "DEC value out of range; ";
	}

	// If SR is negative, this is bad.
	if( is_numeric($radius) && ($radius < 0.) ){
	 $isError = True;
	 $errorMsg .= "SR value is negative; ";
	}

	// If there has been an error, report it as a PARAM and exit.
	if($isError){
	  echo "<RESOURCE type=\"Error message\">\n";
	  printf("<PARAM ID=\"ERROR\" datatype=\"char\" value=\"%s\"/>\n",$errorMsg);
	  echo "</RESOURCE>\n";
	  echo "</VOTABLE>\n";
	  exit;
	}
	// Else, continue!

echo "<DESCRIPTION>\n";
echo "ATNF Pulsar Archive: Conesearch Query\n";
echo "</DESCRIPTION>\n";
echo "<COOSYS ID=\"J2000\" equinox=\"J2000.\" epoch=\"J2000.\" system=\"eq_FK5\"/>\n";
echo "<RESOURCE type=\"conesearch results\">\n";
printf("<PARAM ID=\"RA\" name=\"RA\" datatype=\"float\" unit=\"degrees\" value=\"%10.6f\"></PARAM>\n",$raj_degs);
printf("<PARAM ID=\"DEC\" name=\"DEC\" datatype=\"float\" unit=\"degrees\" value=\"%+11.6f\"></PARAM>\n",$decj_degs);
printf("<PARAM ID=\"SR\" name=\"SR\" datatype=\"float\" unit=\"degrees\" value=\"%10.6f\"></PARAM>\n",$radius);


///////////////////////////////////////////////////////////////////////////
//  CONNECT TO THE MYSQL DATABASE AND STORE THE S70 DATA.
//  THIS IS A TEMPORARY MEASURE -- IDEALLY THE DATA WILL BE IN PLACE 
//   BEFOREHAND.
//

$link = db_connect_admin();

loadS70();

///////////////////////////////////////////////////////////////////////////
	


//////////////////////////////////////////////
// Get the field names to fill the table column headers (FIELD declarations).

$query = "SHOW COLUMNS FROM s70";
$result = mysql_query($query) or die ('Query failed: ' . mysql_error());

$fields = array();
if (mysql_num_rows($result)) {
	while($row = mysql_fetch_assoc($result)) {
		array_push($fields, $row);
	}
}

echo "<TABLE>\n";
print_column_headers($result);


		$whereString = "";

		////////////////////////////
		// Constraint on boundary

	        $angsep_str = "";
		if ($radius) {

	               $angsep_str = "degrees( acos( cos(radians(rajd-$raj_degs))*cos(radians(decjd))*cos(radians($decj_degs))+sin(radians(decjd))*sin(radians($decj_degs))) )";

	               $whereString .= "($angsep_str - 0.25*(bmaj+bmin)) < $radius";

		}


		// Remove any leading or trailing AND and OR
		$whereString = trim($whereString, " AND OR");

		$query = "SELECT *,$angsep_str as angsep FROM s70 WHERE $whereString ORDER by angsep";

		$result = mysql_query($query) or die('Query failed: ' . mysql_error());

		$all_results = array();

		while ($line = mysql_fetch_assoc($result)) {
			array_push($all_results, $line );
		}
		
		$_SESSION['results'] = $all_results;
	
		mysql_free_result($result);
	
		mysql_close($link);

///////////////////////////////////////////////////////////////////////////


	print_data($all_results);

echo "</TABLE>\n";
echo"</RESOURCE>\n";
echo"</VOTABLE>\n";
	?>
<?php

///////////////////////////////////////////////////////////////////////////////////////////////
//
// Function definitions
// --------------------
//
///////////////////////////////////////////////////////////////////////////////////////////////

function print_column_headers() {

/// PRINT VOTABLE HEADERS (<FIELD>) FOR EACH OF THE COLUMNS TO BE INCLUDED

	echo "<FIELD name=\"Filename\" ID=\"col1\" ucd=\"meta.id;meta.main\" datatype=\"char\" arraysize=\"30\"/>\n";
	echo "<FIELD name=\"Field Name\" ID=\"col2\" ucd=\"obs.field;meta.id\" datatype=\"char\" arraysize=\"20\"/>\n";
        echo "<FIELD name=\"Survey\" ID=\"col3\" ucd=\"obs;meta.dataset;meta.id\" datatype=\"char\" arraysize=\"10\"/>\n";
	echo "<FIELD name=\"RA\" ID=\"col4\" ucd=\"pos.eq.ra;meta.main\" ref=\"J2000\" datatype=\"float\" width=\"10\" precision=\"6\" unit=\"deg\"/>\n";
	echo "<FIELD name=\"DEC\" ID=\"col5\" ucd=\"pos.eq.dec;meta.main\" ref=\"J2000\" datatype=\"float\" width=\"11\" precision=\"6\" unit=\"deg\"/>\n";
	echo "<FIELD name=\"BMAJ\" ID=\"col6\" ucd=\"pos.angResolution;phys.angSize.smajAxis\" datatype=\"float\" width=\"6\" precision=\"4\" unit=\"deg\"/>\n";
	echo "<FIELD name=\"BMIN\" ID=\"col7\" ucd=\"pos.angResolution;phys.angSize.sminAxis\" datatype=\"float\" width=\"6\" precision=\"4\" unit=\"deg\"/>\n";
	echo "<FIELD name=\"BPA\" ID=\"col8\" ucd=\"pos.angResolution;pos.posAng\" datatype=\"float\" width=\"6\" precision=\"4\" unit=\"deg\"/>\n";
	echo "<FIELD name=\"UT Date/Time of Observations\" ID=\"col9\" ucd=\"time.start\" datatype=\"char\" arraysize=\"30\"/>\n";
	echo "<FIELD name=\"ObsFreq\" ID=\"col10\" ucd=\"em.freq.central\" datatype=\"float\" width=\"9\" precision=\"4\" unit=\"MHz\"/>\n";
	echo "<FIELD name=\"Channel Bandwidth\" ID=\"col11\" ucd=\"spect.binSize;em.freq\" datatype=\"float\" width=\"9\" precision=\"4\" unit=\"MHz\"/>\n";
	echo "<FIELD name=\"Number of Channels\" ID=\"col12\" ucd=\"em.bin;meta.number\" datatype=\"int\" width=\"6\"/>\n";
	echo "<FIELD name=\"Scan length\" ID=\"col13\" ucd=\"obs.exposure;time.duration\" datatype=\"float\" width=\"9\" precision=\"4\" unit=\"s\"/>\n";
	echo "<FIELD name=\"Sample time\" ID=\"col14\" ucd=\"time.resolution\" datatype=\"float\" width=\"9\" precision=\"4\" unit=\"ms\"/>\n";

}

function print_data($all_results) {
  
  echo "<DATA>\n<TABLEDATA>\n";
  for ($i=0; $i < count($all_results); $i++) {
    $line = $all_results[$i];
    print_data_line($line);
  }
  echo "</TABLEDATA>\n</DATA>\n";

}

function print_data_line($line) {
/// PRINT VOTABLE HEADERS (<FIELD>) FOR EACH OF THE COLUMNS TO BE INCLUDED
	echo "<TR>\n ";
	printf("<TD>%s</TD>",$line['filename']);
	printf("<TD>%s</TD>",$line['src_name']);
	printf("<TD>%s</TD>",$line['survey']);
	printf("<TD>%10.6f</TD>",$line['rajd']);
	printf("<TD>%+11.6f</TD>",$line['decjd']);
	printf("<TD>%6.4f</TD>",$line['bmaj']);
	printf("<TD>%6.4f</TD>",$line['bmin']);
	printf("<TD>%6.4f</TD>",$line['bpa']);
	printf("<TD>%s</TD>",$line['date_obs']);
	printf("<TD>%9.4f</TD>",$line['obsfreq']);
	printf("<TD>%9.4f</TD>",$line['chanbw']);
	printf("<TD>%d</TD>",$line['nchan']);
	printf("<TD>%9.4f</TD>",$line['scanlen']);
	printf("<TD>%9.4f</TD>",$line['tbin']);
	echo "\n</TR>\n";
}

?>
